

100 REM PROGRAM Optos, FILE: OPTOS.BAS
105 REM Written by Paul Bergsman in QBASIC
110 REM
120 REM Repeatedly turn each opto-coupler in FIGURE OPTOS.SCH1 high,
130 REM and then low, until any key is pressed.  Trailing semi-colens in
135 REM lines 1080 and 1100 stop carrage return and line feed transmission.
140 REM
150 D0High = 1: REM  photo-transistor opto-coupler
160 D0Low  = 0
170 D1High = 2: REM  SCR opto-coupler
180 D1Low  = 0
190 D3High = 8: REM  triac opto-coupler
200 D3Low  = 0
240 D5High = 0: REM  SSR, solid state relay
250 D5Low  = 32
260 E = 0: Time = 1
500 REM
510 HighBit = D0High: LowBit = D0Low: REM  photo transistor opto-coupler
520 GOSUB 1000
530 HighBit = D1High: LowBit = D1Low: REM  SCR opto-coupler
540 GOSUB 1000
550 HighBit = D3High: LowBit = D3Low: REM  Triac opto-coupler
560 GOSUB 1000
570 HighBit = D5High: LowBit = D5Low: REM  SCR opto-coupler
580 GOSUB 1000
590 IF INKEY$ = "" THEN GOTO 500 ELSE STOP
600 END
1000 REM
1005 REM -=[ subroutine, Transmit_Data: BYTE ]=-
1007 REM
1010 REM Send data out parallel printer port LPT1
1020 REM Sequence:
1030 REM   set bit to active high
1040 REM   delay
1050 REM   set bit to inactive low
1060 REM   delay
1070 REM
1080 LPRINT CHR$(HighBit); : REM TURN OPTO-COUPLER ON
1090 SLEEP (Time)
1100 LPRINT CHR$(LowBit); : REM TURN OPTO-COUPLER OFF
1110 SLEEP (Time)
1120 RETURN
